/* ===========================================================================
                   RECURSIVE TOWERS OF HANOI (ONE CALL)
For this program see: Pettorossi, A.: "Towers of Hanoi problems: deriving
iterative solutions by program transformation BIT Vol.25 (1985), 327-334.
=========================================================================== */
#include  <iostream.h>
#include  <string>   // not <string.h>. File needed for using strings.
const int Initial=2; // it should be >=0
const int Final=3;   // it should be >=Initial
/*----------------------------------------------------------------------------
Initial and Final are the minimum and maximum number of disks for which the
sequences of moves are constructed.
--------------------------------------------------------------------------- */
string TripleString[3];

void t(int n, string pegA, string pegB, string pegC)
{string Temp[3];
 if (n==0) {for (int i=0; i<3; i++) TripleString[i]=" ";}
 else {t(n-1,pegA,pegC,pegB);
       for (int i=0; i<3; i++) {Temp[i]=TripleString[i];}
       TripleString[0]=Temp[0] + pegA + pegB + Temp[1];
       TripleString[1]=Temp[2] + pegB + pegC + Temp[0];
       TripleString[2]=Temp[1] + pegC + pegA + Temp[2];};};

void main()
{for (int i=Initial; i<=Final; i++)
      {for (int j=0; j<=2; j++) {TripleString[j]=" ";};
      t(i,"A","B","C");
      cout <<"Moves for Hanoi from peg A to peg B of "<<i<<" disks:\n";
      cout << TripleString[0] << "\n\n";};
}
/* input:   output:
------------------------------------------------------------------------------
            Moves for Hanoi from peg A to peg B of 2 disks:
             AC AB CB

            Moves for Hanoi from peg A to peg B of 3 disks:
             AB AC BC AB CA CB AB
--------------------------------------------------------------------------- */
